stages:
  - srcrpm
  - lint
  - build
  - install

image: centos

variables:
  GIT_STRATEGY: none
  RPMBUILD_TOPDIR: "${CI_PROJECT_DIR}/rpmbuild"
  YUM: "yum --setopt=cachedir=${CI_PROJECT_DIR}/.cache/yum --setopt=keepcache=1 --assumeyes"

cache:
  key: "${CI_JOB_NAME}"
  paths:
    - .cache/yum

# -- templates --------------

.yup-update: &yum-update
  ${YUM} update

.yum-init: &yum-init
  ${YUM} update &&
  ${YUM} install
    rpm-build
    python-rpm-macros
    python-srpm-macros
    epel-rpm-macros

.el7: &el7
  image: containers.ligo.org/docker/base:el7

.srcrpm: &srcrpm
  stage: srcrpm
  variables:
    GIT_STRATEGY: fetch
  before_script:
    - *yum-init
    - ${YUM} install make rpmdevtools
  script:
    - make sources
    - rpmbuild
          --define "_topdir ${RPMBUILD_TOPDIR}"
          --define "_sourcedir $(pwd)"
          -bs ./lalmetaio.spec
  artifacts:
    paths:
      - ${RPMBUILD_TOPDIR}/SRPMS

.lint: &lint
  stage: lint
  before_script:
    - *yum-init
    - ${YUM} install rpmlint
  script:
    - rpmlint ${RPMBUILD_TOPDIR}/SRPMS/*.src.rpm

.build: &build
  stage: build
  before_script:
    - *yum-init
    - yum -y install yum-utils
  script:
    - yum-builddep -y ${RPMBUILD_TOPDIR}/SRPMS/lalmetaio*.src.rpm
    - rpmbuild --define "_topdir ${RPMBUILD_TOPDIR}" --rebuild ${RPMBUILD_TOPDIR}/SRPMS/lalmetaio*.src.rpm
    - ls -l $(find ${RPMBUILD_TOPDIR}/RPMS/ -type f)
  artifacts:
    paths:
      - ${RPMBUILD_TOPDIR}/RPMS

.install: &install
  stage: install
  script:
    - yum -y localinstall ${RPMBUILD_TOPDIR}/RPMS/*/*.rpm

# -- src.rpm ----------------

srcrpm:el7:
  <<: *el7
  <<: *srcrpm

# -- lint -------------------

lint:el7:
  <<: *el7
  <<: *lint
  dependencies:
    - srcrpm:el7

# -- build ------------------

build:el7:
  <<: *el7
  <<: *build
  dependencies:
    - srcrpm:el7

# -- install ----------------

install:el7:
  <<: *el7
  <<: *install
  dependencies:
    - build:el7

install:el7-lscsoft-all:
  image: ligo/software:el7
  <<: *install
  dependencies:
    - build:el7
